/******************** (c) Marvell Semiconductor, Inc., 2002 *******************
 *
 * $Header: X:/APCVSDEPOT/Bootloader/AP21/ap21_tftp_boot/board.h,v 1.1.1.1 2002/12/30 20:44:05 cvu Exp $
 *
 * Purpose:
 *    Function prototypes for the bootrom's initial ThumbC boot decision
 *    code.
 *
 * Public Procedures:
 *    boot                    Main entry for the C part of the boot.
 *
 * Private Procedures:
 *    clock_enable            enable Eagle clocks needed to run the boot.
 *
 * Notes:
 *    None.
 *
 *****************************************************************************/

#ifndef _BOARD_H_
#define _BOARD_H_

#define TRUE	1
#define FALSE   0

#define LOAD_XFER_ADDR       0x20000 // This is the dest address of the image



//=============================================================================
//                    PUBLIC PROCEDURES (ANSI Prototypes)
//=============================================================================
/******************************************************************************
 *
 * Name: boot
 *
 * Description:
 *   boot.s calls this to get the ThumbC part of the bootrom going. 
 *
 * Conditions For Use:
 *   None.
 *
 * Arguments:
 *    Arg1 (u32 ): u32ramBist	- I&DSRAM bist result. (raw ARM mrc format).
 *    Arg2 (u32 ): u32tagBist	- I&DTAG  bist result.         "
 *    Arg2 (u32 ): u32cacheBist	- I&DCACHE  bist result.       "
 *
 * Return Value:
 *   None.
 *
 * Notes:
 *   None.
 *
 *****************************************************************************/
extern void boot(UINT32 u32ramBist, UINT32 u32tagBist, UINT32 u32cacheBist);

#endif /* _BOARD_H_ */
