/******************** (c) Marvell Semiconductor, Inc., 2002 *******************
 *
 * $Header: X:/APCVSDEPOT/Bootloader/AP21/ap21_tftp_boot/boot.h,v 1.1.1.1 2002/12/30 20:44:05 cvu Exp $
 *
 * Purpose:
 *    Proto's into the boot assembly code.
 *
 * Public Procedures:
 *    Thumb2ARM               Transfer control to arg1's code ptr
 *
 * Notes:
 *    None.
 *
 *****************************************************************************/

#ifndef _BOOT_H_
#define _BOOT_H_

/******************************************************************************
 *
 * Name: Thumb2ARM
 *
 * Description:
 *   Transfer control to ARG1's value as interpreted as a code
 *    address. Also performs a state switch (thumb -> ARM)
 *
 * Conditions For Use:
 *   None.
 *
 * Arguments:
 *   Arg1( u32 ): 32bit pointer to a code address
 *
 * Return Value:
 *   Never returns.
 *
 * Notes:
 *   None.
 *
 *****************************************************************************/

extern void Thumb2ARM( UINT32 u32CodePtr );

#endif // _BOOT_H_
