#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "elffmt.h"

Elf32_Ehdr g_Elf32_Ehdr;

typedef unsigned long DWORD;
typedef unsigned short WORD;
typedef unsigned  char BYTE;

enum eEndian { LITTLE, BIG };

enum eEndian g_eEndian=LITTLE;
BYTE g_bSwap;

#if 0
void 
mymemcpy(char *to, char *from, unsigned len)
{
  int i;
  for(i=0;i < len;i++) {
    *to++ = *from++;
  }
}
#endif
DWORD
SwapL(DWORD x)
{
    union {
	DWORD x;
	BYTE  b[4];
    } u;
    u.x = x;
    if(g_bSwap) {
	if(g_eEndian == LITTLE) {
	    return (u.b[0] << 24) | (u.b[1] << 16) | (u.b[2] << 8) | u.b[3];
	} else {
	    return (u.b[3] << 24) | (u.b[2] << 16) | (u.b[1] << 8) | u.b[0];
	}
    } else {
	return x;
    }
}
WORD
SwapW(WORD x)
{
    union {
	WORD  x;
	BYTE  b[2];
    } u;
    u.x = x;
    if(g_bSwap) {
	if(g_eEndian == LITTLE) {
	    return (u.b[0] << 8) | u.b[1];
	} else {
	    return (u.b[1] << 8) | u.b[0];
	}
    } else {
	return x;
    }
}
void
SwapBlockL(DWORD *pdw, DWORD dwLen)
{
    DWORD i;
    for(i=0;i < dwLen;i++, pdw++) {
	*pdw = SwapL(*pdw);
    }
}
void
SwapHeader()
{
    g_Elf32_Ehdr.e_type = SwapW(g_Elf32_Ehdr.e_type);
    g_Elf32_Ehdr.e_machine = SwapW(g_Elf32_Ehdr.e_machine);
    g_Elf32_Ehdr.e_version = SwapL(g_Elf32_Ehdr.e_version);
    g_Elf32_Ehdr.e_entry = SwapL(g_Elf32_Ehdr.e_entry);
    g_Elf32_Ehdr.e_phoff = SwapL(g_Elf32_Ehdr.e_phoff);
    g_Elf32_Ehdr.e_shoff = SwapL(g_Elf32_Ehdr.e_shoff);
    g_Elf32_Ehdr.e_flags = SwapL(g_Elf32_Ehdr.e_flags);
    g_Elf32_Ehdr.e_ehsize = SwapW(g_Elf32_Ehdr.e_ehsize);
    g_Elf32_Ehdr.e_phentsize = SwapW(g_Elf32_Ehdr.e_phentsize);
    g_Elf32_Ehdr.e_phnum = SwapW(g_Elf32_Ehdr.e_phnum);
    g_Elf32_Ehdr.e_shentsize = SwapW(g_Elf32_Ehdr.e_shentsize);
    g_Elf32_Ehdr.e_shnum = SwapW(g_Elf32_Ehdr.e_shnum);
    g_Elf32_Ehdr.e_shstrndx = SwapW(g_Elf32_Ehdr.e_shstrndx);
}
void
SwapSectHeader(Elf32_Shdr* shp)
{
    shp->sh_name  = SwapL(shp->sh_name);
    shp->sh_type = SwapL(shp->sh_type);
    shp->sh_flags = SwapL(shp->sh_flags);
    shp->sh_addr = SwapL(shp->sh_addr);
    shp->sh_offset = SwapL(shp->sh_offset);
    shp->sh_size = SwapL(shp->sh_size);
    shp->sh_link = SwapL(shp->sh_link);
    shp->sh_info = SwapL(shp->sh_info);
    shp->sh_addralign = SwapL(shp->sh_addralign);
    shp->sh_entsize = SwapL(shp->sh_entsize);
}
void
SwapPhdrHeader(Elf32_Phdr* php)
{
    php->p_type =   SwapL(php->p_type);
    php->p_offset = SwapL(php->p_offset);
    php->p_vaddr =  SwapL(php->p_vaddr);
    php->p_paddr =  SwapL(php->p_paddr);
    php->p_filesz = SwapL(php->p_filesz);
    php->p_memsz =  SwapL(php->p_memsz);
    php->p_flags =  SwapL(php->p_flags);
    php->p_align =  SwapL(php->p_align);
}

extern union {
    void (*branch) (void);
    int hackfest;
} u;

void
load_and_go()
{
    char *base = (char *)0xfff00000;
    char *curr_off;
    int i;
    Elf32_Phdr *p;
    Elf32_Phdr *pElfPhdrs;

#if 0
    memset((char *)0xd0000000,0,(3*1024*1024));
    memset((char *)0xc0000000,0,(48*1024));
    memset((char *)0x0,0,(128*1024));
    for(;;);
#endif
    memcpy(&g_Elf32_Ehdr, base, sizeof(g_Elf32_Ehdr));
    if(g_Elf32_Ehdr.e_ident[EI_DATA] == ELFDATA2MSB) {
      g_bSwap = 1;
    } else {
      g_bSwap = 0;
    }
    SwapHeader();
    curr_off = base + g_Elf32_Ehdr.e_phoff;
    pElfPhdrs = malloc(sizeof(Elf32_Phdr) * g_Elf32_Ehdr.e_phnum);
    if(!pElfPhdrs) {
	exit(1);
    }
    p = pElfPhdrs;
    for(i=0;i < g_Elf32_Ehdr.e_phnum;i++) {
	memcpy((char *)p, curr_off, sizeof(Elf32_Phdr));
	SwapPhdrHeader(p);
	p++;
	curr_off += sizeof(Elf32_Phdr);
    }
    for(i=0;i < g_Elf32_Ehdr.e_phnum;i++) {
	p = &pElfPhdrs[i];
	curr_off = base + p->p_offset;
	memcpy((void *)p->p_vaddr, curr_off, p->p_filesz);
    }
    u.hackfest = g_Elf32_Ehdr.e_entry;
    u.branch();
}
