/******************** (c) Marvell Semiconductor, Inc., 2002 *******************
 *
 * $Header: X:/APCVSDEPOT/Bootloader/AP21/ap21_tftp_boot/gpio.h,v 1.1.1.1 2002/12/30 20:44:05 cvu Exp $
 *
 * Purpose:
 *    This file contains the function prototypes and definitions for the
 *    GPIO setup code.
 *
 * Public Procedures:
 *    gpio_out_en             Enable the GPIO pins for output.
 *    gpwr                    Write 16 bits of data to the GPIO pins
 *
 * Notes:
 *    None.
 *
 *****************************************************************************/

#ifndef _GPIO_H_
#define _GPIO_H_


//=============================================================================
//                    PUBLIC PROCEDURES (ANSI Prototypes)
//=============================================================================

/******************************************************************************
 *
 * Name: gpwr
 *
 * Description:
 *   Write a UINT16 to the previously enabled GPIO pins.
 *
 * Conditions For Use:
 *   GPIO Clock should be enabled before attempting to use. (In PAU).
 *
 * Arguments:
 *   Arg1( UINT16 ): 16 bits of data to appear at the pins.
 *
 * Return Value:
 *   None.
 *
 * Notes:
 *   None.
 *
 *****************************************************************************/
extern void gpwr(UINT16 u16data );

#endif /* _GPIO_H_ */


