extern void 
setup_uart( void )
{
    u32 u32tmp;
    /* Mode based register file in the synopsys IP for the 16550. Need
       to write a special pattern to LINE_CONTROL and then the low
       registers in the file become config registers. Finally write
       the EIGHT_BIT request to the LINE_CONTROL and also deassert
       DLAB in doing so, this reverts the low register back to their
       RX&TX functions */
    REG32(LINE_CONTROL)  = DLAB;
    REG32(DIVISOR_LOW)   = BAUDRATE_DIV;
    REG32(LINE_CONTROL)  = EIGHT_BIT;
    /* Get the value from the pad ctrl reg. so we can selectively
       disable the USB pin */
    u32tmp               = REG32(PI_PAD_CTRL);
    /* De-assert bit11 the mux for USB/UART --> UART (according to the
       verilog) */  
    REG32(PI_PAD_CTRL)   = u32tmp & (~bit(11)); 
}
