#include <stdlib.h>
#include <string.h>
#include "types.h"
#include "decls.h"
const DWORD ROM_IS_ZERO         = 1;
const DWORD ROM_LZH_COMPRESSION = 2;
const DWORD ROM_ZIP_COMPRESSION = 3;
const DWORD ROM_ENTRY           = 4;

extern union {

    void (*branch) (void);

    int hackfest;

} u;





int inflate(void);

BYTE *addr;

BYTE  *dst;



//+****************************************************************************

int get_byte()

{

    return *addr++;

}

void write_buf(int fd, BYTE *buf, unsigned int cnt)

{

    memcpy(dst, buf, cnt);

    dst += cnt;

}



void

unpack_and_go()

{

    DWORD state;
    unsigned int flash_addr;

    memset(0, 0, 128*1024);

    memset((char *)0xc0000000, 0, 48*1024);

    memset((char *)0xd0000000, 0, 1*1024*1024);

    flash_addr = 0xfff00000;
    addr = (BYTE*)flash_addr;

#ifdef ENABLE_BACKUP_CODE
    while (flash_addr < 0xfffe0000) {
        state = *(DWORD *)addr;
        if (state != 0x4c56524d) {  //magic word
            flash_addr += 0x10000;
            addr = (BYTE*)flash_addr;  //search every 64k for valid binary code 
        } else
            break;
    }
    if (flash_addr == 0xfffe0000) {
        //use oringinal code
        flash_addr = 0xfff00000;
        addr = (BYTE*)flash_addr;
    }else
        addr += 8;  //magic word + len
#endif

    for (;;) {

        // Read address

        dst = *(BYTE **)addr;

        addr += 4;

        // state 

        state = *(DWORD *)addr;

        addr += 4;

        if (state == ROM_ZIP_COMPRESSION) {

            inflate();

            if ((DWORD)addr & 3) { // Align up

                addr += 4-((DWORD)addr & 3);

            }

        } else if (state == ROM_ENTRY) {

            disable_cache();

            u.hackfest = (int)dst;

            u.branch();

        } else {

            // what to do here...

            for (;;);

        }

    }

}

