/******************** (c) Marvell Semiconductor, Inc., 2001 *******************
*
* $Header: E:\\APCVSDEPOT/wlan/prod/ap/ap31/bridge/incl/ap_mib.h,v 1.12 2004/02/09 16:13:18 ctlaw Exp $
*
* Purpose:
*    This file contains the definitions for the Management Informaton Base
*    (MIB).
*
* Public Procedures:
*    None.
*
* Notes:
*    The structure of the MIB is given in the IEEE 802.11 standard.
*
*****************************************************************************/

#ifndef _MIB_H_
#define _MIB_H_

/*============================================================================= */
/*                               INCLUDE FILES */
/*============================================================================= */
#include "wltypes.h"
#include "IEEE_types.h"
#include "wl_mib.h"

/*============================================================================= */
/*                            PUBLIC DEFINITIONS */
/*============================================================================= */
#define mib_MAXIMUM_DATA_RATES  8
#define mib_MAX_DEFAULT_KEYS    4




/*============================================================================= */
/*                          PUBLIC TYPE DEFINITIONS */
/*============================================================================= */

/*---------------------------------------------------------------------------*/
/*                     Enumerated types used for the MIB                     */
/*---------------------------------------------------------------------------*/

/*============================================================================= */
/*                       STATION MANAGEMENT ATTRIBUTES */
/*============================================================================= */

/*-----------------------------*/
/* Station Configuration Table */
/*-----------------------------*/

UINT8 mib_preAmble;
UINT8 mib_rxAntenna;
UINT8 mib_txAntenna;
UINT8 mib_broadcastssid;
UINT8 mib_defaultkeyindex;
UINT8 mib_dhcpenable;
UINT8 mib_dhcpstatechange;
UINT8 mib_enableFixedRateTx;
UINT8 mib_txDataRate;  /* fixed rate to be used for b only clients */
UINT8 mib_txDataRateG; /* fixed rate to be used for g clients */
UINT8 mib_currentmacaddress[6];
UINT8 mib_wep; /* special mode */
UINT8 mib_wlanfilterno;
UINT8 mib_wlanfiltermode;
UINT8 mib_wlanfiltermac[ 256 * 6];
UINT8 mib_beaconDisable;
UINT8 mib_DeviceName[16+1];
UINT8 mib_shortSlotTime;
UINT8 mib_ErpProtEnabled;
UINT8 mib_ApMode;
UINT8 mib_forceProtectiondisable;

/* WiPod 5-in-1 */
UINT8 mib_wipodMode;

#ifdef WDS_FEATURE
#ifndef MAX_WDS_PORT
#define MAX_WDS_PORT   6
#endif
#define WDS_CONFIGURED_KEY          0x2345a55a
UINT8 mib_wdsEnable;
UINT8 mib_wdsno;
UINT8 mib_wdsmac[MAX_WDS_PORT*6];
UINT8 mib_disableAssoc;
UINT8 mib_wdsOption; /* WDS interop option */
#endif 
extern MRVL_MIB_RSN_GRP_KEY mib_MrvlRSN_GrpKey;

#ifdef MACACCESSTABLE
typedef enum
{
    WLAN_FILTER_DISABLE,
    WLAN_FILTER_ALLOW,
    WLAN_FILTER_BLOCK
} MAC_ACCESS_TABLE;
#endif


extern MIB_STA_CFG                *mib_StaCfg_p;
extern MIB_OP_DATA                *mib_OpData_p;
extern MIB_AUTH_ALG               *mib_AuthAlg_p;
extern MIB_WEP_DEFAULT_KEYS       *mib_WepDefaultKeys_p;
extern MIB_PHY_SUPP_DATA_RATES_TX *mib_PhySuppTxDataRates_p;
extern MIB_PHY_DSSS_TABLE         *PhyDSSSTable_p;
extern MIB_PRIVACY_TABLE          *mib_PrivacyTable_p;
extern MIB_PHY_TX_POWER_TABLE     *mib_PhyTxPwrData_p;
extern MIB_PHY_ANT_LIST           *mib_PhyAntList_p;
extern MIB_PHY_ANT_TABLE          *mib_PhyAntData_p;
extern MIB_COUNTERS               *mib_Counters_p;
extern MIB_DHCP                   *mib_DHCP_p;
#ifdef OS_VxW
extern MIB_DHCP                   *mib_DHCP_Eth_p;
extern MIB_DHCP                   *mib_DHCP_WAN_p;
#endif
extern MIB_RSNCONFIG              *mib_RSNConfig_p;
extern MIB_RSNCONFIG_AUTH_SUITES  *mib_RSNConfigAuthSuites_p;
extern MIB_RSNSTATS               *mib_RSNStats_p;
extern MIB_RSNCONFIG_UNICAST_CIPHERS   *mib_RSNConfigUnicastCiphers_p;
#ifdef BURST_MODE
extern MIB_BURST_MODE             *mib_BurstMode_p;
#endif
extern BOOLEAN mib_InitPriv(MIB_802DOT11 *mib);
extern void mib_RestoreDefaults();
extern void mib_Reset();

/*#define isStrictShareMode() !mib_wep */
/*#define isAuthAlgTypeMatch(x) (x == mib_AuthAlg_p->Type) */
/*#define isWepRequired() (mib_StaCfg_p->PrivOption == TRUE) */

#endif /* _MIB_H_ */
