#ifndef _USRCFG_H_
#define _USRCFG_H_ 
/*
*                Copyright 2003, Marvell Semiconductor, Inc.
* This code contains confidential information of Marvell Semiconductor, Inc.
* No rights are granted herein under any patent, mask work right or copyright
* of Marvell or any third party.
* Marvell reserves the right at its sole discretion to request that this code
* be immediately returned to Marvell. This code is provided "as is".
* Marvell makes no warranties, express, implied or otherwise, regarding its
* accuracy, completeness or performance.
*/

/*!
 * \file    usrcfg.c
 * \brief   Define user configuration data structure saved on flash
 *
 * $Revision: 1.2 $
 * $Date: 2003/09/22 21:49:14 $
 */

typedef struct usr_Cfg_t
{
    UINT32 uc_mfgDataLocation;
    UINT16 uc_maxStns;
    UINT8 uc_gpioSwResetPin;
    UINT8 uc_StrictShareMode;
    UINT8 us_StrictOpenMode;
    UINT8 us_GOnlyModeErpEnable;
    UINT8 us_NoCalibration;
}
PACK_END usr_Cfg_t; 

extern usr_Cfg_t usrCfg;

#define mfgDataAddress()    (usrCfg.uc_mfgDataLocation)
#define GPIO_PIN_SW_RESET   (1<<(usrCfg.uc_gpioSwResetPin))
#define MAX_STNS            (usrCfg.uc_maxStns)
#define Strict_Share_Mode() (usrCfg.uc_StrictShareMode)
#define Strict_Open_Mode()  (usrCfg.us_StrictOpenMode)
#define NoCalibration()     (usrCfg.us_NoCalibration)
#define G_Mode_ErpEnable()  (usrCfg.us_GOnlyModeErpEnable)

void usr_Cfg_Init(void);

#endif
