/******************** (c) Marvell Semiconductor, Inc., 2001 *******************
 *
 * $Header: E:\\APCVSDEPOT/wlan/prod/ap/ap31/bridge/incl/util.h,v 1.2 2003/09/22 21:49:19 jployer Exp $
 *
 * Purpose:
 *    This file proivdes general purpose utilities.
 *
 * Public Procedures:
 *    util_CopyList     Copies a list that is terminated by a zero entry
 *    util_ListLen      Returns the length of a list that is terminated by a
 *                      zero entry
 *    util_EmptyList    Determines if a list is empty or not
 *
 * Private Procedures:
 *    None.
 *
 * Notes:
 *    None.
 *
 *****************************************************************************/
#ifndef _UTIL_H_
#define _UTIL_H_

/*============================================================================= */
/*                               INCLUDE FILES */
/*============================================================================= */
#include "wltypes.h"


/*============================================================================= */
/*                    PUBLIC PROCEDURES (ANSI Prototypes) */
/*============================================================================= */

/******************************************************************************
 *
 * Name: util_CopyList
 *
 * Description:
 *    Routine to copy a list of bytes that is represented by an array where
 *    an entry of 0 indicates the end of the list if the list does not
 *    contain the maximum number of entries.
 *
 * Conditions For Use:
 *    None.
 *
 * Arguments:
 *    Arg1 (  o): Dest_p  - Pointer to the location a list is to be copied to
 *    Arg2 (i  ): Src_p   - Pointer to the location of the list to be copied
 *    Arg3 (i  ): MaxSize - The maximum allowed length of the list
 *
 * Return Value:
 *    The length of the list.
 *
 * Notes:
 *    The length is computed by assuming that as soon as there is a zero
 *    in the array, that indicates the end of the data in the array.
 *
 *****************************************************************************/
extern UINT8 util_CopyList(UINT8 *Dest_p, UINT8 *Src_p, UINT32 MaxSize);


#endif

