/******************** (c) Marvell Semiconductor, Inc., 2001 *******************
* 
* $Header: E:\\APCVSDEPOT/wlan/prod/ap/ap31/bridge/src/bcngen.c,v 1.30 2004/06/15 20:12:15 jshen Exp $ 
* 
* Purpose: 
*    This file contains the implementations of the beacon update functions. 
* 
* Public Procedures: 

* 
* Private Procedures: 
*      
* 
* Notes: 
*    None. 
* 
*****************************************************************************/
#include "buildModes.h"
#include "wltypes.h"
#include "IEEE_types.h"
#include "sysinfo.h"
#include "osif.h"
#include "bcngen.h"
#include "tkip.h"
#include "macMgmtMlme.h"
#include "ap_api.h"
#include "ap_mib.h"
#include "memmap.h"
#include "wl_macros.h"
#include "wlmac.h"
#include "txsched.h"

#define OVERLAP_CHAN_PERF_TUNE 1

#ifdef USE_NEW_OSIF
static TASK_HANDLE bcngenTH;

//wuming temp
//static UINT8  Stack[sysinfo_MAC_MGMT_TASK_STACK_SIZE]__attribute__ ((section (".itcmbuf")));
static UINT8  Stack[sysinfo_MAC_MGMT_TASK_STACK_SIZE];
#endif
#define bcngen_TBTT_EVENT   (1 >> 0 )
#define BCNGEN_EVENT_TRIGGERS bcngen_TBTT_EVENT


typedef enum
{
    COPY_FULL,
    COPY_END,
    COPY_BYTE
} CopyMode_e;
txBcnInfo_t BcnTxInfoBuf __attribute__ ((section (".sqbuf")));
txBcnInfo_t *BcnTxInfo = &BcnTxInfoBuf;
txBcnInfo_t PrbRspTxInfoBuf __attribute__ ((section (".sqbuf")));
txBcnInfo_t *PrbRspTxInfo = &PrbRspTxInfoBuf;
macmgmtQ_MgmtMsg_t PrbRspBuf __attribute__ ((section (".sqbuf")));
macmgmtQ_MgmtMsg_t * PrbRspBuf_p = (macmgmtQ_MgmtMsg_t *)&PrbRspBuf;
static UINT16 UpdateProbeRespBuffer(IEEEtypes_StartCmd_t *StartCmd);

macmgmtQ_MgmtMsg_t Bcn __attribute__ ((section (".sqbuf")));
macmgmtQ_MgmtMsg_t * BcnBuffer_p = (macmgmtQ_MgmtMsg_t *)&Bcn;


extern IEEEtypes_SsIdElement_t macSsId;
extern IEEEtypes_SuppRatesElement_t SuppRateSet;

#ifdef ERP

extern IEEEtypes_ExtSuppRatesElement_t ExtSuppRateSet;
extern IEEEtypes_DataRate_t OpRateSet[IEEEtypes_MAX_DATA_RATES_G];
extern IEEEtypes_DataRate_t BasicRateSet[IEEEtypes_MAX_DATA_RATES_G];
extern UINT32 BasicRateSetLen;
extern UINT32 OpRateSetLen;
UINT8 *BcnErpInfoLocation_p;
UINT8 *PrbrspErpInfoLocation_p;

#else

extern IEEEtypes_SuppRatesElement_t OpRateSet;
extern IEEEtypes_SuppRatesElement_t BasicRateSet;

#endif


IEEEtypes_Tim_t Tim;
IEEEtypes_Tim_t *TimPtr;
UINT8 TrafficMap[251];
IEEEtypes_RSN_IE_t thisStaRsnIE;

static IEEEtypes_MacAddr_t BcastAddr = { 0xff, 0xff, 0xff, 0xff, 0xff, 0xff};
extern IEEEtypes_MacAddr_t macBssId;
extern UINT8 mib_broadcastssid;
extern MIB_RSNCONFIG              *mib_RSNConfig_p;
extern MIB_RSNCONFIG_UNICAST_CIPHERS   *mib_RSNConfigUnicastCiphers_p;
extern MIB_RSNCONFIG_AUTH_SUITES       *mib_RSNConfigAuthSuites_p;

static void BcnTask(OS_DATA Data);

/**
 * Fill Beacon Buffer with ERP parameters
 * 
 * @param pBcnBuf Pointer to start of ERP parameters in beacon buffer
 * @return The number of bytes written
 */

#ifdef ERP
inline UINT16 ErpBufUpdate(UINT8 *pBcnBuf, IEEEtypes_StartCmd_t *StartCmd,UINT16 MsgSubType)
{
    UINT8 * pNextElement = pBcnBuf;
    IEEEtypes_ExtSuppRatesElement_t *pExtSuppRate;
    IEEEtypes_ERPInfoElement_t *pErpInfo;

    UINT16 byteCnt = 0;
    UINT16 totalLen = 0;

    /* ERP Info*/
    pErpInfo = pNextElement;
    pErpInfo->ElementId = ERP_INFO;
    pErpInfo->Len       = 1;
    *(UINT8 *)&pErpInfo->ERPInfo = 0;
    if ( MsgSubType == IEEE_MSG_PROBE_RSP)
    {
        PrbrspErpInfoLocation_p = &pErpInfo->ERPInfo;  /* Will be used later probe rsp update when 
                                             * b only stations associate */
    }
    else
    {
        BcnErpInfoLocation_p = &pErpInfo->ERPInfo;
    }
    byteCnt = sizeof(IEEEtypes_InfoElementHdr_t) + pErpInfo->Len;

    totalLen += byteCnt;
    pNextElement += byteCnt;
    pExtSuppRate = (IEEEtypes_ExtSuppRatesElement_t *)pNextElement;
    *pExtSuppRate = ExtSuppRateSet;

    byteCnt = sizeof(IEEEtypes_InfoElementHdr_t) + ExtSuppRateSet.Len;

    totalLen += byteCnt;
    return totalLen;
}
/* ErpInfo is updated when the first NonErp station associates and when the last NonErp station
 * leaves the BSS */
#define DISABLE_B_AP_CHECK 1
void bcngen_UpdateBeaconErpInfo(BOOLEAN SetFlag)
{
#ifdef  ENABLE_WIFI_PROTECTION 	
    extern UINT32 BStnAroundCnt;
    extern UINT32 BAPCount;
    extern UINT8 BarkerPreambleSet;
#endif
    if (SetFlag)
    {
#ifdef  ENABLE_WIFI_PROTECTION 	
#ifdef DISABLE_B_AP_CHECK
	    if(bOnlyStnCnt)
#else
   		if((bOnlyStnCnt) || (BAPCount> 0))
#endif
   		{
    	    if(BarkerPreambleSet)
    	    {
    	        *BcnErpInfoLocation_p  = 0x7;
	            *PrbrspErpInfoLocation_p = 0x7;	
    	    }
  	        else
   	        {
#endif
                *BcnErpInfoLocation_p = 0x3;
                *PrbrspErpInfoLocation_p = 0x3;

            }
#ifdef ENABLE_WIFI_PROTECTION
	    }
	    else if(BStnAroundCnt && !bOnlyStnCnt)
	    {
	    	 *BcnErpInfoLocation_p = 0x2;
           	 *PrbrspErpInfoLocation_p = 0x2;
        }
   	}
#endif
    else
    {
        *BcnErpInfoLocation_p = 0x0;
        *PrbrspErpInfoLocation_p = 0x0;
    }
}
#endif
/******************************************************************************
 * 
 * Name: bcngen_UpdateBeaconBuffer 
 * 
 * Description: 
 *     
 * 
 * Conditions For Use: 
 *    None. 
 * 
 * Arguments: 
 *    None. 
 * 
 * Return Value: 
 *    Status indicating success or failure. 
 * 
 * Notes: 
 *    None. 
 * 
 * PDL: 
 *
 * END PDL 
 * 
 *****************************************************************************/
void bcngen_UpdateBeaconBuffer(IEEEtypes_StartCmd_t *StartCmd)
{
    UINT8 * NextElementPtr;
    IEEEtypes_SsIdElement_t *SsIdPtr;
    IEEEtypes_SuppRatesElement_t *SuppRatesPtr;
    IEEEtypes_PhyParamSet_t *PhyParamSetPtr;
    IEEEtypes_SsParamSet_t *SsParamSetPtr;
    UINT32 RateCnt;
    UINT16 totalLen = 0;
    UINT16 byteCnt;

    BcnBuffer_p->Hdr.Duration = 0;
    BcnBuffer_p->Hdr.FrmCtl.ProtocolVersion = 0;
    BcnBuffer_p->Hdr.FrmCtl.Type = IEEE_TYPE_MANAGEMENT;
    BcnBuffer_p->Hdr.FrmCtl.Subtype = IEEE_MSG_BEACON;
    BcnBuffer_p->Hdr.FrmCtl.ToDs = 0;
    BcnBuffer_p->Hdr.FrmCtl.FromDs = 0;
    BcnBuffer_p->Hdr.FrmCtl.MoreFrag = 0;
    BcnBuffer_p->Hdr.FrmCtl.Retry = 0;
    BcnBuffer_p->Hdr.FrmCtl.PwrMgmt = 0;
    BcnBuffer_p->Hdr.FrmCtl.MoreData = 0;
    BcnBuffer_p->Hdr.FrmCtl.Wep = 0;
    BcnBuffer_p->Hdr.FrmCtl.Order = 0;
    memcpy(&BcnBuffer_p->Hdr.DestAddr, &BcastAddr, sizeof(IEEEtypes_MacAddr_t));
    memcpy(&BcnBuffer_p->Hdr.SrcAddr, &macBssId, sizeof(IEEEtypes_MacAddr_t));
    memcpy(&BcnBuffer_p->Hdr.BssId, &macBssId, sizeof(IEEEtypes_MacAddr_t));

    BcnBuffer_p->Body.Bcn.BcnInterval = StartCmd->BcnPeriod;
    BcnBuffer_p->Body.Bcn.CapInfo = StartCmd->CapInfo;

    NextElementPtr = (UINT8 *) & BcnBuffer_p->Body.Bcn.SsId;
    SsIdPtr = &BcnBuffer_p->Body.Bcn.SsId;

    if (mib_broadcastssid == TRUE)
    {
        *SsIdPtr = macSsId;
    }
    else
    { /** FALSE CASE: NEED TO BLANK OFF SSID **/

        *SsIdPtr = macSsId;
        memset(SsIdPtr->SsId, 0, SsIdPtr->Len);
    }


    NextElementPtr = NextElementPtr + 2 + SsIdPtr->Len;
    SuppRatesPtr = (IEEEtypes_SuppRatesElement_t *)NextElementPtr;
    SuppRatesPtr->ElementId = SUPPORTED_RATES;
    RateCnt = 0;
#ifndef ERP
    *SuppRatesPtr = OpRateSet;
    for (i = 0; i < OpRateSet.Len; i++)
    {
        for (j = 0; j < BasicRateSet.Len; j++)
        {
            if (OpRateSet.Rates[i] == BasicRateSet.Rates[j])
            {
                SuppRatesPtr->Rates[i]
                = SuppRatesPtr->Rates[i] | 0x80;
                break;
            }
        }
    }
    NextElementPtr = NextElementPtr + 2 + OpRateSet.Len;
#else
    *SuppRatesPtr = SuppRateSet;
    NextElementPtr = NextElementPtr +2 + SuppRateSet.Len;
#endif
    PhyParamSetPtr = (IEEEtypes_PhyParamSet_t *)NextElementPtr;
    if (*(UINT8 *)&StartCmd->PhyParamSet == FH_PARAM_SET )
    {
        PhyParamSetPtr->FhParamSet =
        StartCmd->PhyParamSet.FhParamSet;
        NextElementPtr = NextElementPtr + sizeof(IEEEtypes_FhParamSet_t);
    }
    else if (*(UINT8 *)&StartCmd->PhyParamSet == DS_PARAM_SET)
    {
        PhyParamSetPtr->DsParamSet =
        StartCmd->PhyParamSet.DsParamSet;
        NextElementPtr = NextElementPtr + sizeof(IEEEtypes_DsParamSet_t);
    }
    
    if (mib_PrivacyTable_p->RSNEnabled)
    {
        // Set capability info.privacy bit for Beacon and probe rsp.
        BcnBuffer_p->Body.Bcn.CapInfo.Privacy = 1;

        InitThisStaRsnIE();

        // add IE to beacon.
        NextElementPtr += AddRSN_IE( (IEEEtypes_RSN_IE_t*)NextElementPtr );
    }
    else
    {
        // ReSet capability info.privacy bit for Beacon and probe rsp.
        if ( (mib_StaCfg_p->PrivOption && mib_PrivacyTable_p->PrivInvoked ) )
            BcnBuffer_p->Body.Bcn.CapInfo.Privacy = 1;
        else
            BcnBuffer_p->Body.Bcn.CapInfo.Privacy = 0;
    }

    
    SsParamSetPtr = (IEEEtypes_SsParamSet_t *)NextElementPtr;
    if (StartCmd->BssType == BSS_INFRASTRUCTURE )
    {
        SsParamSetPtr->CfParamSet =
        StartCmd->SsParamSet.CfParamSet;
        NextElementPtr = NextElementPtr + sizeof(IEEEtypes_CfParamSet_t);
    }
    else if (StartCmd->BssType == BSS_INDEPENDENT)
    {
        SsParamSetPtr->IbssParamSet =
        StartCmd->SsParamSet.IbssParamSet;
        NextElementPtr = NextElementPtr + sizeof(IEEEtypes_IbssParamSet_t);
    }

    TimPtr = (IEEEtypes_Tim_t *)NextElementPtr;
    TimPtr->ElementId = TIM;
    TimPtr->DtimPeriod = StartCmd->DtimPeriod;
    TimPtr->BitmapCtl = 0;
    TimPtr->PartialVirtualBitmap[0] = 0;
    TimPtr->Len = 4;
    // Also, update the local TIM buffer
    Tim.ElementId = TIM;
    Tim.DtimPeriod = StartCmd->DtimPeriod;
    Tim.BitmapCtl = 0;
    Tim.PartialVirtualBitmap[0] = 0;
    Tim.Len = 4;
    byteCnt = sizeof(IEEEtypes_InfoElementHdr_t) + TimPtr->Len;
    NextElementPtr += byteCnt;


#ifdef ERP
#ifdef ENABLE_AP_MODES
    if (mib_ApMode != AP_MODE_B_ONLY)
#endif
        totalLen += ErpBufUpdate(NextElementPtr, StartCmd,IEEE_MSG_BEACON);
    BcnBuffer_p->Hdr.FrmBodyLen = totalLen;
    NextElementPtr += totalLen; 
#endif

    totalLen = (UINT32)NextElementPtr - (UINT32)BcnBuffer_p -
               sizeof(IEEEtypes_MgmtHdr_t);

    BcnBuffer_p->Hdr.FrmBodyLen = totalLen;
    BcnTxInfo->RetryCnt = 0;
    BcnTxInfo->Status = 0;
    BcnTxInfo->TxParam = 0x700;    /* for b client  */
    BcnTxInfo->Service = 0;
    BcnTxInfo->Rate = 0;/* RateIndex1Mbit; */
    BcnTxInfo->Power = 0;
    BcnTxInfo->HdrAddr = (IEEEtypes_Frame_t *)BcnBuffer_p;
    /*--------------------------------------------------------------*/
    /* The following offset to the CF Parameters in the beacon is   */
    /* calculated for the MAC transmit hardware as follows:         */
    /*                                                              */
    /* 1) First, the offset to be calculated is the number of bytes */
    /*    the transmitter will transmit, starting from the frame    */
    /*    control field in the IEEE header, up to the point of the  */
    /*    CF parameter set information in the beacon body.          */
    /*                                                              */
    /* 2) Since the beacon body byte length field is not to be      */
    /*    transmitted, we must subtract out the length of this      */
    /*    field.                                                    */
    /*                                                              */
    /* 3) Since the 4th address in the IEEE header is not to be     */
    /*    transmitted (since there is no 4th address for management */
    /*    messages), the transmitter skips over this field - hence, */
    /*    we must subtract out the length of this field as well.    */
    /*                                                              */
    /* So, taking the difference between pointers to the CF         */
    /* parameter set and the beacon buffer pointer, and subtracting */
    /* out the additional fields mentioned above, yields the        */
    /* number of bytes tranmitted up to the point of the CF         */
    /* paramters.                                                   */
    /*--------------------------------------------------------------*/
    BcnTxInfo->CfOffset = (UINT32)SsParamSetPtr - (UINT32)BcnBuffer_p - 8;
    /* 8 = 6 bytes of 4th addr and 2 bytes of body length field */
    BcnTxInfo->TimOffset = (UINT32)TimPtr - (UINT32)BcnBuffer_p - 8 ;
    /* 8 = 6 bytes of 4th addr and 2 bytes of body length field */

    /*--------------------------------------------------------------*/
    /* The probe response length is merely the complete length of   */
    /* the beacon frame that is actually tranmitted - not just the  */
    /* beacon body. Hence, its length is the body length, plus what */
    /* is transmitted in the IEEE header, and                       */
    /* also the FCS length.                                         */
    /*--------------------------------------------------------------*/
    BcnTxInfo->ProbeRespLen = UpdateProbeRespBuffer(StartCmd);
    BcnTxInfo->Tsf0 = 0;
    BcnTxInfo->Tsf1 = 0;
    BcnTxInfo->FragBasicDurId0 = 0;
    BcnTxInfo->FragBasicDurId1 = 0;
}
/******************************************************************************
 * 
 * Name:  bcngen_EnableBcnFreeIntr
 * 
 * Description:  
 * Conditions For Use: 
 *    None. 
 * 
 * Arguments: 
 *    None. 
 * 
 * Return Value: 
 *    Status indicating success or failure. 
 * 
 * Notes: 
 *    None. 
 * 
 * PDL: 
 *
 * END PDL 
 * 
 *****************************************************************************/
void bcngen_EnableBcnFreeIntr(void)
{

    /*Enable Beacon Free interrupt;*/
    WL_WRITE_WORD(MIR_INTR_MASK, WL_REGS32(MIR_INTR_MASK) | MSK_BCN_FREE);

    return ;
}

/******************************************************************************
 * 
 * Name:  bcngen_DisableBcnFreeIntr
 * 
 * Description:  
 * Conditions For Use: 
 *    None. 
 * 
 * Arguments: 
 *    None. 
 * 
 * Return Value: 
 *    Status indicating success or failure. 
 * 
 * Notes: 
 *    None. 
 * 
 * PDL: 
 *
 * END PDL 
 * 
 *****************************************************************************/
void bcngen_DisableBcnFreeIntr(void)
{

    /*Disable Beacon Free interrupt;*/
    WL_WRITE_WORD(MIR_INTR_MASK, WL_REGS32(MIR_INTR_MASK) & ~(MSK_BCN_FREE));

    return ;
}
/******************************************************************************
 * 
 * Name: bcn_BeaconFreeIsr  
 * 
 * Description: This ISR updates the TIM in the Beacon buffer. When the 
 *    BCN_BUSY interrupt is raised, the HW MAC is just done with using the
 *    beacon buffer and it is safe for the MAC SW to update the TIM fields.
 *    After updating the beacon buffer, the interrupt is disabled.  
 * 
 * Conditions For Use: 
 *    None. 
 * 
 * Arguments: 
 *    None. 
 * 
 * Return Value: 
 *    Status indicating success or failure. 
 * 
 * Notes: 
 *    None. 
 * 
 * PDL: 
 *
 * END PDL 
 * 
 *****************************************************************************/
static UINT32 CBP_QID_pre = TC7_QID;
static UINT32 BRATE_QID_pre = TC7_QID;
void bcngen_BeaconFreeIsr()
{
    /*----------------------------------------------------------------*/
    /* The beacon body length is calculated as the difference between */
    /* the TIM pointer and the beacon buffer pointer, less the size   */
    /* of the header since that is obviously not part of the body and   */
    /* addition of  size of TIM field                                  */
    /*----------------------------------------------------------------*/
#ifdef POWER_SAVE

    /*BcnBuffer_p->Hdr.FrmBodyLen = (UINT32)TimPtr - (UINT32)BcnBuffer_p -
                                  sizeof(IEEEtypes_GenHdr_t) + sizeof(UINT8) element id
                                  + sizeof(IEEEtypes_Len_t)  length field
                                  + Tim.Len ; 
    */
    /*   *TimPtr = Tim; */
    /*memcpy((UINT8*)TimPtr, (UINT8*)&Tim, sizeof(IEEEtypes_InfoElementHdr_t) + Tim.Len);*/
#endif
    if (macCurSlotTimeMode != macChangeSlotTimeModeTo)
    {
        if (macChangeSlotTimeModeTo == SLOT_TIME_MODE_LONG)
        {
            WL_WRITE_WORD(MPP_DCF_SLOT_TIME,20);
#ifdef OVERLAP_CHAN_PERF_TUNE
            WL_WRITE_WORD(MPP_AIFS_TIME6, 45);  /* sifs + 2 * slot time; 40->45 AP32 022404 uses 45 */
            WL_WRITE_WORD(MPP_AIFS_TIME7, 28); 
#else
            WL_WRITE_WORD(MPP_AIFS_TIME6,50);  /* sifs + 2 * slot time */
            WL_WRITE_WORD(MPP_AIFS_TIME7,50);  /* sifs + 2 * slot time */
#endif            
            macCurSlotTimeMode = SLOT_TIME_MODE_LONG;
            BcnBuffer_p->Body.Bcn.CapInfo.ShortSlotTime = 0;
            PrbRspBuf_p->Body.Bcn.CapInfo.ShortSlotTime = 0;
#ifdef OVERLAP_CHAN_PERF_TUNE
            WL_WRITE_WORD(TX_CW7_MIN, 0x8);
            WL_WRITE_WORD(TX_CW7_MAX, 0x1f);

            WL_WRITE_WORD(TX_CW6_MIN, 0x3); /* Sync with AP32: 6->3 */
            WL_WRITE_WORD(TX_CW6_MAX, 0x1f);/* Sync with AP32: 0x20->0x1f */

            CBP_QID = TC7_QID;
            BRATE_QID = TC6_QID;
            CBP_QID_pre = CBP_QID;
            BRATE_QID_pre = BRATE_QID;
#else
            WL_WRITE_WORD(TX_CW7_MIN, 0x3);
            WL_WRITE_WORD(TX_CW7_MAX, 0x7f);

            WL_WRITE_WORD(TX_CW6_MIN, 0x7);
            WL_WRITE_WORD(TX_CW6_MAX, 0x40);
#endif
        }
        else
        {
            WL_WRITE_WORD(MPP_DCF_SLOT_TIME,9);
#ifdef OVERLAP_CHAN_PERF_TUNE
            WL_WRITE_WORD(MPP_AIFS_TIME6, 28);  /* sifs + 2 * slot time */
            WL_WRITE_WORD(MPP_AIFS_TIME7, 20);  /* sifs + 2 * slot time */
#else

            WL_WRITE_WORD(MPP_AIFS_TIME7, 28);  /* sifs + 2 * slot time */
            WL_WRITE_WORD(MPP_AIFS_TIME6, 40);  /* sifs + 2 * slot time */
#endif
            macCurSlotTimeMode = SLOT_TIME_MODE_SHORT;
            BcnBuffer_p->Body.Bcn.CapInfo.ShortSlotTime = 1;
            PrbRspBuf_p->Body.Bcn.CapInfo.ShortSlotTime = 1;
#ifdef OVERLAP_CHAN_PERF_TUNE
            WL_WRITE_WORD(TX_CW7_MIN, 3);
            WL_WRITE_WORD(TX_CW7_MAX, 0x1f);

            WL_WRITE_WORD(TX_CW6_MIN, 0x3); /* Sync with AP32: 6->3 */
            WL_WRITE_WORD(TX_CW6_MAX, 0x1f);/* Sync with AP32: 0x20->0x1f */

            CBP_QID = TC7_QID;
            BRATE_QID = TC7_QID;
            CBP_QID_pre = CBP_QID;
            BRATE_QID_pre = BRATE_QID;
#else
            WL_WRITE_WORD(TX_CW7_MIN, 12);
            WL_WRITE_WORD(TX_CW7_MAX, 0x7f);

            WL_WRITE_WORD(TX_CW6_MIN, 0x7);
            WL_WRITE_WORD(TX_CW6_MAX, 0x3f); /** suggested change by Peter Loc **/
#endif
        }
    }

    if (AssocStationsCnt > 3) {
        CBP_QID = TC7_QID;
        BRATE_QID = TC7_QID;
        WL_WRITE_WORD(TX_CW7_MIN, 0x3);
    }else
    {
        CBP_QID = CBP_QID_pre;
        BRATE_QID = BRATE_QID_pre;

        if(BRATE_QID==TC6_QID) {
            WL_WRITE_WORD(TX_CW7_MIN, 0x8);
        }
    }

    /*Disable Beacon Free interrupt */
    bcngen_DisableBcnFreeIntr();
}
/******************************************************************************
 * 
 * Name:  
 * 
 * Description: 
 *     
 * 
 * Conditions For Use: 
 *    None. 
 * 
 * Arguments: 
 *    None. 
 * 
 * Return Value: 
 *    Status indicating success or failure. 
 * 
 * Notes: 
 *    Refer to Protocol spec for the variables used.Section 7.3.2.6 page 57-58 
 * 
 * PDL: 
 *
 * END PDL 
 * 
 *****************************************************************************/
void bcngen_UpdateBitInTim(UINT16 Aid, BOOLEAN Set)
{

    static UINT32 LowByte = 0, HighByte = 0;
    CopyMode_e CopyMode;
    static UINT32 N1, N2, prevN2;
    UINT32 ByteNum, HwordNum, BitNum, Len, i;

    int addedLen, trailBytes;

    char tmpBuf[IEEEtypes_MAX_MGMT_BODY_LEN];


    if ( Aid == 0)
    {
        if (Set == TRUE)
        {
            /* Set bit 0 in the bit map control */
            Tim.BitmapCtl = Tim.BitmapCtl | 0x01;
        }
        else
        {
            Tim.BitmapCtl = Tim.BitmapCtl & 0xFE ;
        }
        return ;
    }

    /* Set the corresponding bit in the traffic Map */
    ByteNum = Aid / 8;
    HwordNum = Aid / 16;
    BitNum = Aid % 8;
    CopyMode = COPY_BYTE;
    if ( Set)
    {
        if (ByteNum < N1*2 )
        {
            N1 = Aid / 16;
            CopyMode = COPY_FULL;
        }
        if (ByteNum > N2)
        {
            prevN2 = N2;
            N2 = Aid / 8;
            CopyMode = COPY_END;
        }
        TrafficMap[ByteNum] = TrafficMap[ByteNum] | ( 1 << BitNum);
        Tim.PartialVirtualBitmap[ByteNum] |= (1 << BitNum);
    }
    else
    {
        if ((ByteNum < LowByte) || (ByteNum > HighByte))
            return ;
        TrafficMap[ByteNum] = TrafficMap[ByteNum] & (( 1 << BitNum) ^ 0xff);
        Tim.PartialVirtualBitmap[ByteNum] &= (( 1 << BitNum) ^ 0xff);
        if ( HwordNum == N1 && *((UINT16*)TrafficMap + HwordNum) == 0)
        {
            CopyMode = COPY_FULL;
            /* Find the next non zero halfword */
            for ( i = N1 + 2; i <= HighByte; i += 2)
            {
                if ((*(UINT16 *)TrafficMap) + i != 0)
                {
                    N1 = i / 2;
                    break;
                }
            }
        }
        else if ( ByteNum == N2 && TrafficMap[ByteNum] == 0)
        {
            CopyMode = COPY_END;
            /* find the previous non zero byte */
            for (i = N2 - 1; i >= LowByte;i--)
            {
                if (TrafficMap[i] != 0)
                {
                    N2 = i;
                }
            }
        }
    }
    Len = (N2 - N1 * 2) + 4;

    /* if the lowest byte did not change, copy only the changed byte,
     * if the lowest byte changes, copy the entire map */
    /* copy from byte N1 *2 on to partial bit map bytes */
    TimPtr->BitmapCtl = TimPtr->BitmapCtl & (0x80 | N1);
    Tim.Len = Len;
#if 0
    Tim.PartialVirtualBitmap[0] = 0;
    if (CopyMode == COPY_BYTE)
        Tim.PartialVirtualBitmap[ByteNum] = TrafficMap[ByteNum];
    else if (CopyMode == COPY_FULL)
    {
        for (i = N1 * 2; i <= N2; i++)
        {
            Tim.PartialVirtualBitmap[i] = TrafficMap[i];
        }
    }
    else if ( CopyMode == COPY_END)
    {
        for (i = prevN2 + 1; i <= N2; i++)
        {
            Tim.PartialVirtualBitmap[i] = TrafficMap[i];
        }
    }
#endif
#if 1 /* Moved to Beacon Free ISR  */

    /* This patch prevents corrupted beacon. */
    addedLen = Tim.Len - TimPtr->Len; /* negative = reduced length */
    if(addedLen!=0)
    {
os_EnterCriticalSection;
        trailBytes = BcnBuffer_p->Hdr.FrmBodyLen 
                            - ( (UINT32)TimPtr - (UINT32)BcnBuffer_p - sizeof(IEEEtypes_GenHdr_t) 
                                + sizeof(IEEEtypes_InfoElementHdr_t) + TimPtr->Len );

        memcpy(tmpBuf, ((UINT8 *)TimPtr) + sizeof(IEEEtypes_InfoElementHdr_t) + TimPtr->Len, trailBytes);
        memcpy(((UINT8 *)TimPtr) + sizeof(IEEEtypes_InfoElementHdr_t) + Tim.Len, tmpBuf, trailBytes);

        /* Update beacon and TIM length with new value */
        TimPtr->Len = Tim.Len;
        BcnBuffer_p->Hdr.FrmBodyLen += addedLen;
        BcnErpInfoLocation_p += addedLen;
os_ExitCriticalSection;
    } 
    memcpy((UINT8 *)TimPtr, (UINT8 *)&Tim, sizeof(IEEEtypes_InfoElementHdr_t) + Tim.Len);
#endif

    /* Safer update, the beacon should be updated only when beacon free interrupt
     * occurs */
    /* Enable Beacon Free interrupt */
    bcngen_EnableBcnFreeIntr();

}
/******************************************************************************
 * 
 * Name:  
 * 
 * Description: 
 *     
 * 
 * Conditions For Use: 
 *    None. 
 * 
 * Arguments: 
 *    None. 
 * 
 * Return Value: 
 *    Status indicating success or failure. 
 * 
 * Notes: 
 *    None. 
 * 
 * PDL: 
 *
 * END PDL 
 * 
 *****************************************************************************/
void SendTBTTEvent()
{
#ifdef USE_NEW_OSIF
    os_EventTrigger(bcngenEH, bcngen_TBTT_EVENT);
#else
    os_EventTrigger(sysinfo_BCNGEN_EVENT, bcngen_TBTT_EVENT);
#endif
}
/******************************************************************************
 * 
 * Name:  
 * 
 * Description: 
 *     
 * 
 * Conditions For Use: 
 *    None. 
 * 
 * Arguments: 
 *    None. 
 * 
 * Return Value: 
 *    Status indicating success or failure. 
 * 
 * Notes: 
 *    None. 
 * 
 * PDL: 
 *
 * END PDL 
 * 
 *****************************************************************************/
extern WL_STATUS bcngen_Init(void)
{
    WL_STATUS status;
#ifdef USE_NEW_OSIF
    if ((status = os_TaskCreate(&bcngenTH,
                                BcnTask,
                                (OS_DATA)0,
                                "Bcngen",
                                (void *)Stack,
                                sysinfo_MAC_MGMT_TASK_STACK_SIZE,
                                sysinfo_MAC_MGMT_TASK_PRI)) == OS_SUCCESS)
    {
        os_EventInit(&bcngenEH);
#else
    if ((status = os_TaskCreate(sysinfo_BCNGEN_TASK,
                                BcnTask,
                                (os_Addrword_t)0,
                                sysinfo_BCNGEN_TASK_NAME,
                                sysinfo_MAC_MGMT_TASK_STACK_SIZE,
                                sysinfo_MAC_MGMT_TASK_PRI)) == OS_SUCCESS)
    {
        os_EventInit(sysinfo_BCNGEN_EVENT);
#endif
        return OS_SUCCESS;
    }
    return(OS_FAIL);
}
/******************************************************************************
 * 
 * Name:  
 * 
 * Description: 
 *     
 * 
 * Conditions For Use: 
 *    None. 
 * 
 * Arguments: 
 *    None. 
 * 
 * Return Value: 
 *    Status indicating success or failure. 
 * 
 * Notes: 
 *    None. 
 * 
 * PDL: 
 *
 * END PDL 
 * 
 *****************************************************************************/
extern void bcngen_Start(void)
{
#ifdef USE_NEW_OSIF
    os_TaskResume(bcngenTH);
#else
    os_TaskResume(sysinfo_BCNGEN_TASK);
#endif
}
/******************************************************************************
 * 
 * Name:  
 * 
 * Description: 
 *     
 * 
 * Conditions For Use: 
 *    None. 
 * 
 * Arguments: 
 *    None. 
 * 
 * Return Value: 
 *    Status indicating success or failure. 
 * 
 * Notes: 
 *    None. 
 * 
 * PDL: 
 *
 * END PDL 
 * 
 *****************************************************************************/
static void BcnTask(OS_DATA Data)
{
    OS_EVENTS EventsTriggered;
    while (1)
    {
#ifdef USE_NEW_OSIF
        EventsTriggered = os_EventWait(bcngenEH,
#else
        EventsTriggered = os_EventWait(sysinfo_BCNGEN_EVENT,
#endif
                                       BCNGEN_EVENT_TRIGGERS,
                                       OS_EVENT_WAITMODE_CLR_OR);
    }
    if (EventsTriggered == 0)
    {
        /* do nothing */
    }
    else
    {
        if ( EventsTriggered & bcngen_TBTT_EVENT)
        {
            /* Call the function to tx the beacon buffer */
        }
    }
}


/**
 * Update the Probe Response buffer
 * Similar to updating beacon buffer
 * 
 * @param StartCmd Pointer to start command parameters
 * @return Number of bytes in the probe response
 */
static UINT16 UpdateProbeRespBuffer(IEEEtypes_StartCmd_t *StartCmd)
{
    UINT8 * NextElementPtr;
    IEEEtypes_SsIdElement_t *SsIdPtr;
    IEEEtypes_SuppRatesElement_t *SuppRatesPtr;
    IEEEtypes_PhyParamSet_t *PhyParamSetPtr;
    IEEEtypes_SsParamSet_t *SsParamSetPtr;
    UINT32 RateCnt;
    UINT16 totalLen;
    UINT16 byteCnt;
    PrbRspBuf_p->Hdr.Duration = 0;
    PrbRspBuf_p->Hdr.FrmCtl.ProtocolVersion =0;
    PrbRspBuf_p->Hdr.FrmCtl.Type = IEEE_TYPE_MANAGEMENT;
    PrbRspBuf_p->Hdr.FrmCtl.Subtype = IEEE_MSG_PROBE_RSP;
    PrbRspBuf_p->Hdr.FrmCtl.ToDs = 0;
    PrbRspBuf_p->Hdr.FrmCtl.FromDs = 0;
    PrbRspBuf_p->Hdr.FrmCtl.MoreFrag = 0;
    PrbRspBuf_p->Hdr.FrmCtl.Retry = 0;
    PrbRspBuf_p->Hdr.FrmCtl.PwrMgmt = 0;
    PrbRspBuf_p->Hdr.FrmCtl.MoreData = 0;
    PrbRspBuf_p->Hdr.FrmCtl.Wep = 0;
    PrbRspBuf_p->Hdr.FrmCtl.Order = 0;

    memcpy(&PrbRspBuf_p->Hdr.DestAddr,&BcastAddr,sizeof(IEEEtypes_MacAddr_t));
    memcpy(&PrbRspBuf_p->Hdr.SrcAddr,&macBssId,sizeof(IEEEtypes_MacAddr_t));
    memcpy(&PrbRspBuf_p->Hdr.BssId,&macBssId,sizeof(IEEEtypes_MacAddr_t));

    PrbRspBuf_p->Body.Bcn.BcnInterval = StartCmd->BcnPeriod;
    PrbRspBuf_p->Body.Bcn.CapInfo =  StartCmd->CapInfo;

    NextElementPtr = (UINT8 *)&PrbRspBuf_p->Body.Bcn.SsId;
    SsIdPtr = &PrbRspBuf_p->Body.Bcn.SsId;
    *SsIdPtr = macSsId;

    NextElementPtr = NextElementPtr + 2 + SsIdPtr->Len;
    SuppRatesPtr = (IEEEtypes_SuppRatesElement_t *)NextElementPtr;
    SuppRatesPtr->ElementId = SUPPORTED_RATES;
    RateCnt = 0;
#ifndef ERP
    *SuppRatesPtr = OpRateSet;
    for (i = 0; i < OpRateSet.Len; i++)
    {
        for (j = 0; j < BasicRateSet.Len; j++)
        {
            if (OpRateSet.Rates[i] == BasicRateSet.Rates[j])
            {
                SuppRatesPtr->Rates[i]
                = SuppRatesPtr->Rates[i] | 0x80;
                break;
            }
        }
    }        
    NextElementPtr = NextElementPtr + 2 + OpRateSet.Len;
#else
    *SuppRatesPtr = SuppRateSet;
    NextElementPtr = NextElementPtr +2 + SuppRateSet.Len;
#endif
    PhyParamSetPtr = (IEEEtypes_PhyParamSet_t *)NextElementPtr;
    if (*(UINT8 *)&StartCmd->PhyParamSet ==  FH_PARAM_SET )
    {
        PhyParamSetPtr->FhParamSet =
        StartCmd->PhyParamSet.FhParamSet; 
        NextElementPtr = NextElementPtr + sizeof(IEEEtypes_FhParamSet_t);
    }
    else if (*(UINT8 *)&StartCmd->PhyParamSet == DS_PARAM_SET)
    {
        PhyParamSetPtr->DsParamSet =
        StartCmd->PhyParamSet.DsParamSet;
        NextElementPtr = NextElementPtr + sizeof(IEEEtypes_DsParamSet_t); 
    }
    
    if (mib_PrivacyTable_p->RSNEnabled)
    {
        // Set capability info.privacy bit for Beacon and probe rsp.
        PrbRspBuf_p->Body.Bcn.CapInfo.Privacy = 1;

        //InitThisStaRsnIE();

        // add IE.
        NextElementPtr += AddRSN_IE( (IEEEtypes_RSN_IE_t*)NextElementPtr );
    }
    else
    {
        // ReSet capability info.privacy bit for Beacon and probe rsp.
        if ( (mib_StaCfg_p->PrivOption && mib_PrivacyTable_p->PrivInvoked ) )
            PrbRspBuf_p->Body.Bcn.CapInfo.Privacy = 1;
        else
            PrbRspBuf_p->Body.Bcn.CapInfo.Privacy = 0;
    }

    
    SsParamSetPtr = (IEEEtypes_SsParamSet_t *)NextElementPtr;
    if (StartCmd->BssType == BSS_INFRASTRUCTURE )
    {
        SsParamSetPtr->CfParamSet =
        StartCmd->SsParamSet.CfParamSet;
        NextElementPtr = NextElementPtr + sizeof(IEEEtypes_CfParamSet_t);
    }
    else if (StartCmd->BssType == BSS_INDEPENDENT)
    {
        SsParamSetPtr->IbssParamSet =
        StartCmd->SsParamSet.IbssParamSet;
        NextElementPtr = NextElementPtr + sizeof(IEEEtypes_IbssParamSet_t);
    }
#if 0
    if (mib_PrivacyTable_p->RSNEnabled == TRUE)
    {
        /* Set capability info.privacy bit for Beacon and probe rsp. */
        PrbRspBuf_p->Body.Bcn.CapInfo.Privacy = 1;
        /* add IE. */
        NextElementPtr += AddRSN_IE( (IEEEtypes_RSN_IE_t*)NextElementPtr );
    }
#endif

#ifdef TURBO_SETUP
    NextElementPtr += AddTS_IE( (UINT8*)NextElementPtr );
#endif
    totalLen = (UINT32)NextElementPtr - (UINT32)PrbRspBuf_p -
               sizeof(IEEEtypes_MgmtHdr_t);
    /* Now fill in the Ext Rate elements */

#ifdef ERP
    byteCnt = 0;
#ifdef ENABLE_AP_MODES
    if (mib_ApMode != AP_MODE_B_ONLY)
#endif
        byteCnt =  ErpBufUpdate(NextElementPtr, StartCmd,IEEE_MSG_PROBE_RSP);
    NextElementPtr += byteCnt;
    totalLen += byteCnt;
#endif
/*
    if (mib_PrivacyTable_p->RSNEnabled == TRUE)
    {
        // Set capability info.privacy bit for Beacon and probe rsp.
        PrbRspBuf_p->Body.Bcn.CapInfo.Privacy = 1;
        // add IE.
        NextElementPtr += AddRSN_IE( (IEEEtypes_RSN_IE_t*)NextElementPtr );
        totalLen += sizeof(IEEEtypes_RSN_IE_t);
    }
*/
    PrbRspBuf_p->Hdr.FrmBodyLen = totalLen;

    /* Fill in the Tx Info for Probe response */
    PrbRspTxInfo->RetryCnt = 3; /*DEFAULT_RETRY_COUNT; */
    PrbRspTxInfo->Status = 0;
    PrbRspTxInfo->HdrAddr = (IEEEtypes_Frame_t *)PrbRspBuf_p;
    PrbRspTxInfo->TxParam = 0x700;
    PrbRspTxInfo->Service = 0;
    PrbRspTxInfo->Rate = 0; /*DEFAULT_TX_DATARATE_ID;  bit map of rate register 1-2Mbit/sec */
    PrbRspTxInfo->Power = 0;
    PrbRspTxInfo->CfOffset = (UINT32)SsParamSetPtr - (UINT32)PrbRspBuf_p - 8;
    PrbRspTxInfo->TimOffset = (UINT32)NextElementPtr - (UINT32)PrbRspBuf_p - 8 ;
    /* probe resp len is ( bodylen + transmittable header len + fcs len - tim len )*/
    /*PrbRspTxInfo->ProbeRespLen = PrbRspBuf_p->Hdr.FrmBodyLen + 24 + 4 - 6; */
    /* probe resp len is ( bodylen + transmittable header len + fcs len)*/
    PrbRspTxInfo->ProbeRespLen = PrbRspBuf_p->Hdr.FrmBodyLen + 24 + 4;
    PrbRspTxInfo->Tsf0 = 0;
    PrbRspTxInfo->Tsf1 = 0;
    PrbRspTxInfo->FragBasicDurId0 = 0;
    PrbRspTxInfo->FragBasicDurId1 = 0;

    return(PrbRspTxInfo->ProbeRespLen);
}

void InitThisStaRsnIE()
{
    thisStaRsnIE.ElemId = 221;
    thisStaRsnIE.Len = 22;
    thisStaRsnIE.OuiType[0] = 0x0;
    thisStaRsnIE.OuiType[1] = 0x50;
    thisStaRsnIE.OuiType[2] = 0xf2;
    thisStaRsnIE.OuiType[3] = 0x01;
    thisStaRsnIE.Ver[0] = 0x01;
    thisStaRsnIE.Ver[1] = 0x0;
    memcpy(thisStaRsnIE.GrpKeyCipher, mib_RSNConfig_p->MulticastCipher, 4);
    thisStaRsnIE.PwsKeyCnt[0] = 0x01;
    thisStaRsnIE.PwsKeyCnt[1] = 0x0;
    memcpy(thisStaRsnIE.PwsKeyCipherList, mib_RSNConfigUnicastCiphers_p->UnicastCipher, 4);
    thisStaRsnIE.AuthKeyCnt[0] = 0x01;
    thisStaRsnIE.AuthKeyCnt[1] = 0x0;
    memcpy(thisStaRsnIE.AuthKeyList, mib_RSNConfigAuthSuites_p->AuthSuites, 4);
    //thisStaRsnIE.RsnCap[0] = 0x0;
    //thisStaRsnIE.RsnCap[1] = 0x0;
}

/* Add RSN IE to a frame body */
UINT16 AddRSN_IE(IEEEtypes_RSN_IE_t* pNextElement)
{
    memcpy( pNextElement, &thisStaRsnIE, sizeof(IEEEtypes_RSN_IE_t) );
    return( sizeof(IEEEtypes_RSN_IE_t) );
}
