/******************** (c) Marvell Semiconductor, Inc., 2001 *******************
* 
* $Header $ 
* 
* Purpose: 
* 
* Public Procedures: 
* 
* Private Procedures: 
* 
* Notes: 
*    None. 
* 
*****************************************************************************/

/*============================================================================= */
/*                               INCLUDE FILES */
/*============================================================================= */
#include "wltypes.h"
#include "buildModes.h"
#include "IEEE_types.h"
#include "osif.h"
#include "sysinfo.h"
#include "timer.h"
#include "wl_mib.h"
#include "wl_hal.h"
#include "ap_api.h"
#include "apflash.h"
#include "etherLow.h"
#include "ether.h"
#include "wl_macros.h"
#include "eth_debug.h"
#include "pool.h"
#include "stats.h"

/*============================================================================= */
/*                                DEFINITIONS */
/*============================================================================= */
#define LED_ADDR   0x1000000c
#ifdef USE_NEW_OSIF

static TASK_HANDLE idleTH;
//wuming temp
//static UINT8  Stack[sysinfo_IDLE_TASK_STACK_SIZE]__attribute__ ((section (".itcmbuf")));
static UINT8  Stack[sysinfo_IDLE_TASK_STACK_SIZE];

#endif
/*============================================================================= */
/*                              TYPE DEFINITIONS */
/*============================================================================= */
/* None. */

/*============================================================================= */
/*                         IMPORTED PUBLIC VARIABLES */
/*============================================================================= */

extern int ReadPhy(UINT32 offset);
extern int WritePhy(UINT32 offset, UINT32 data);
extern UINT8 dbgPolling;


/*============================================================================ */
/*                          MODULE LEVEL VARIABLES */
/*============================================================================= */
UINT32 fe_cmd_ready __attribute__ ((section (".sqbuf")));
UINT32 fe_cmd __attribute__ ((section (".sqbuf")));
UINT32 fe_offset __attribute__ ((section (".sqbuf")));
UINT32 fe_data __attribute__ ((section (".sqbuf")));
static UINT32 val __attribute__ ((section (".sqbuf")));
int count __attribute__ ((section (".sqbuf"))) = 0;

UINT32 dCount = 0;



/*============================================================================= */
/*                   PRIVATE PROCEDURES (ANSI Prototypes) */
/*============================================================================= */

static void test_femac(void);
void IdleTask( OS_DATA Data );
void MacMonitor(void);



/*============================================================================= */
/*                         CODED PUBLIC PROCEDURES */
/*============================================================================= */

extern WL_STATUS idle_Init( void )
{
    WL_STATUS status;
#ifdef USE_NEW_OSIF
    if ((status = os_TaskCreate(&idleTH,
                                IdleTask,
                                (OS_DATA)0,
                                sysinfo_IDLE_TASK_NAME,
                                (void *)Stack,
                                sysinfo_IDLE_TASK_STACK_SIZE,
                                sysinfo_IDLE_TASK_PRI)) == OS_SUCCESS)
#else
    if ((status = os_TaskCreate(sysinfo_IDLE_TASK,
                                IdleTask,
                                (os_Addrword_t)0,
                                sysinfo_IDLE_TASK_NAME,
                                sysinfo_IDLE_TASK_STACK_SIZE,
                                sysinfo_IDLE_TASK_PRI)) == OS_SUCCESS)
#endif
    {

        return (OS_SUCCESS);
    }

    return (OS_FAIL);
}


extern void idle_Start( void )
{
#ifdef USE_NEW_OSIF
    os_TaskResume(idleTH);
#else
    os_TaskResume(sysinfo_IDLE_TASK);
#endif
}

/*============================================================================= */
/*                         CODED PRIVATE PROCEDURES */
/*============================================================================= */

/******************************************************************************
 * 
 * Name: IdleTask 
 * 
 * Description: 
 * 
 * Conditions For Use: 
 *   None
 * 
 * Arguments: 
 *   Arg1 (i  ): Data - Data passed to the task; not actually used - just 
 *                      included to conform to the structure the OS 
 *                      expects when creating a task 
 * 
 * Return Value: 
 *   None. 
 * 
 * Notes: 
 *   None. 
 * 
 * PDL: 
 * END PDL 
 * 
 *****************************************************************************/
 
extern POOL pool_hd;

UINT8 stats_buf[2000];
void displayStats(void)
{
    msi_wl_StatsDisplay(stats_buf);
    etherBugSend("\n\n%s\n\n%d %d %x %x\n", stats_buf, 
             pool_hd.nFree__, pool_hd.nMin__, WL_REGS32(0x8000a890),WL_REGS32(0x8000a8b0)); 
}


void IdleTask( OS_DATA Data )
{


    while (1)
    {
#if 0 // for MII
#if !defined(AP31E) && !defined(AP31CLIENT)
        MacMonitor();
#endif

#ifndef NOETHERDEBUG
        if(dbgPolling)
        {
            if(dCount++ == 100000)
            {
                dCount = 0;

                msi_wl_StatsDisplay(stats_buf);
                etherBugSend("\n\n%s\n\n%d %d %x %x\n", stats_buf, 
                         pool_hd.nFree__, pool_hd.nMin__, WL_REGS32(0x8000a890),WL_REGS32(0x8000a8b0)); 
            /*etherBugPoll(); */
            }
        }
#endif      
#endif // for MII  
#if 0
        if ( count++ == 100000)
        {
           count = 0;
            test_femac();
            apctlSwLedDisable(0);
            apctlSwLedDisable(1);
            apctlSwLedDisable(2);
            apctlSwLedDisable(3);

	}
#endif
    }

}



static void test_femac(void)

{

    if (fe_cmd_ready)
    {
        switch (fe_cmd)
        {
        case 0 :
            WL_READ_WORD(fe_offset, fe_data);
            break;
        case 1 :
            WL_READ_HWORD(fe_offset, fe_data);
            break;
        case 2:
            WL_READ_BYTE(fe_offset, fe_data);
            break;
        case 3:
            WL_WRITE_WORD(fe_offset, fe_data);
            break;
        case 4:
            WL_WRITE_HWORD(fe_offset, fe_data);
            break;
        case 5 :
            WL_WRITE_BYTE(fe_offset, fe_data);
            break;
        case 6:
            fe_data = ReadPhy(fe_offset);
            break;
        case 7:
            WritePhy(fe_offset, fe_data);
            break;
        default:
            WL_READ_WORD(fe_offset, fe_data);
            break;
        }
        fe_cmd_ready = 0;
    }

}


void MacMonitor(void)
{
#ifndef ETHERSWITCH
    static unsigned long then = 0;
    unsigned long now = cyg_current_time();

    if(now-then > 400)
    {
        ether_port_down = (WL_REGS32(ETHER0_PORT_STATUS_REG) & 0x0008)?0:1;
        then = now;
        apctlGPIOWrite(10, ether_port_down);

    }
#endif
}

