/******************** (c) Marvell Semiconductor, Inc., 2001 ******************* 
* 
* Purpose: 
*    This file contains the implementations of the function prototypes for the 
*    Bridge Task. 
* 
* Public Procedures: 
*    bridge_Init       Initialzies Bridge Task and related components 
*    bridge_Start      Starts running the Bridge Task 
* 
* Private Procedures: 
*    None  
* 
* Notes: 
*    None. 
* 
*****************************************************************************/ 

#include "wltypes.h"
#include "buildModes.h"
#include "IEEE_types.h"
#include "tkip.h"
#include "tx80211.h"
#include "txstats.h"

struct sTxStats TxStats[3] __SQRAM__;

/*calling this directly in RateAdapt.c */
void UpdateTxStats(txInfo_t *txInfo_p)
{
             UINT16 stnId;
             /*Get the Station ID here. */
             /*stnId = txInfo_p->SwInfo.StnId; */
             stnId=0;

             TxStats[stnId].RetryCnt+= txInfo_p->RetryCnt;
             if (txInfo_p->Status)
             {
                 TxStats[stnId].Drops++;
             }
             else
             {
                 TxStats[stnId].Success++;
             }
             TxStats[stnId].Rate= txInfo_p->Rate;
             TxStats[stnId].PktLen= (txInfo_p->HdrAddr)->Hdr.FrmBodyLen;
}

  
