#ifndef _BUILD_MODES_H_
#define _BUILD_MODES_H_
/*
*                Copyright 2003, Marvell Semiconductor, Inc.
* This code contains confidential information of Marvell Semiconductor, Inc.
* No rights are granted herein under any patent, mask work right or copyright
* of Marvell or any third party.
* Marvell reserves the right at its sole discretion to request that this code
* be immediately returned to Marvell. This code is provided "as is".
* Marvell makes no warranties, express, implied or otherwise, regarding its
* accuracy, completeness or performance.
*/

/*!
 * \file    buildModes.h
 * \brief   Contains conditional compilation flags for the build
 *
 * $Revision: 1.6 $
 * $Date: 2003/11/21 18:56:15 $
 */

/*=============================================================================
 *                               PUBLIC TYPE DEFINITIONS
 *=============================================================================
 */
#define CONDOR 1    
#define ENABLE_AGING  1 
#define POWER_SAVE    1
#ifndef CONDOR
#define ENABLE_88MHZ_CLK  1 
/*#define ENABLE_132MHZ_CLK 1 */
#else 
/*#define ENABLE_80MHZ_CLK   1 */
/*#define ENABLE_106MHZ_CLK  1 */
/*#define ENABLE_128MHZ_CLK  1 */
#define ENABLE_160MHZ_CLK  1
/*#define ENABLE_176MHZ_CLK  1 */
#endif

#define WEP_ITCM 1 /* Put software WEP function in ITCM for performance */

#define ENABLE_RATE_ADAPTATION 1 
/* This should be defined for enabling
 * any of the two rate adapt schemes 
 * Of the two schemes, any one or both
 * may be enabled */
/*#define ENABLE_RATE_ADAPTATION_FOLLOW_STN 1 */ /* Follows the station rate */ 
/*#define ENABLE_RATE_ADAPTATION_ON_TX_ERR 1  */ /* Rate adapt, on tx error */
#define ENABLE_RATE_ADAPTATION_BASEBAND 1 /*Uses the OPERA scheme to set the BaseBand Values*/
#ifdef ENABLE_RATE_ADAPTATION_BASEBAND
#define ENABLE_OSCILLATION_CODE
#endif /*ENABLE_RATE_ADAPTATION_BASEBAND */

/*#define SW_TXWEP 1 */ /* SOftware TX WEP */
#define INCL_STATS 1 
/*#define ENABLE_WEP 1 */ /* Sets mib default to WEP enable */
#define ENABLE_TX_INTR 1
#define FREE_IN_TXTASK 1
#define ICACHE_ENABLE 1  
#define MACACCESSTABLE 1
#define PASS_IPX 1 
/*#define ENABLE_UART 1   */

/*#define ENABLE_MFG_CALIBRATION 1    */
/*#define ENABLE_ENET_MAC_FILTER 1    */
/* To let the multicast packets, we need to put
 * ethernet mac in promiscuous mode. To do this
* comment out this define */
#define ENABLE_TX_FRAG 1

/*#define MAC_STATE_MONITOR 1 */


#define ERP    1
/*#define BUFFER_WITH_RESERVED_SPACE 1  */
/*#define ONTHEFLY_DECRYPT_DISABLED 1   */
/*#define OFFSET_USED 1                 */
#define ENABLE_ERP_PROTECTION 1
#define ENABLE_AP_MODES 1

#define DHCP_TIMEOUT_IN_SEC 30
/*#define ENABLE_ETH_DEBUG 1*/

/* Define to include RF evaluation web page */
/*#define MAIN_PAGE_EVALTOOL            */

/* Temp define while porting over 11B and 11G co-exist */
/* Can remove it all once we know it's stable */
#define PORT_COEXIST

#ifdef WDS_FEATURE 
#define ENABLE_WDS 1
#endif 
#endif /* _BUILD_MODES_H_ */
