#                Copyright 2003, Marvell International Ltd.
# This code contains confidential information of Marvell Semiconductor, Inc.
# No rights are granted herein under any patent, mask work right or copyright
# of Marvell or any third party.
# Marvell reserves the right at its sole discretion to request that this code
# be immediately returned to Marvell. This code is provided "as is".
# Marvell makes no warranties, express, implied or otherwise, regarding its
# accuracy, completeness or performance.

# Common make settings for eCos to include at the end of the local makefile
#
# History:
#    8/18/03  cvu         Added target "depend"
#    5/3/03   cvu         Added more comments
#

# This makefile requires that the following variables be defined
# either in the file hdr.mak (common headr makefile) or in the local
# makefile in each module source folder:
#    OBJ_DIR     :: folder for object files
#    BUILD_DIR   :: the main build folder
#    ROOT_DIR    :: the root of the entire source tree

# Rule to create $(OBJ_DIR) if $(OBJ_DIR) does not exist
MAKE_OBJ_DIR:
	@-if !(test -d $(OBJ_DIR)); then mkdir $(OBJ_DIR); fi;

# Rule to create $(LIB_DIR) if $(LIB_DIR) does not exist
MAKE_LIB_DIR:
	@-if !(test -d $(LIB_DIR)); then mkdir $(LIB_DIR); fi;

clean:
	-rm -f $(OBJS)
	-rm -f ${DST}
	-rm -f $(DEPEND_FILES)
	-rm -f .depend

# Dependencies
DEPEND_FILES = ${SRCS:%.c=%.d}

depend: $(DEPEND_FILES)
	/bin/find .. -name "*.d" | xargs cat >.depend


-include .depend

