#ifndef _KEYMGMT_COMMON_H_
#define _KEYMGMT_COMMON_H_

#define NONCE_SIZE          32
#define EAPOL_MIC_KEY_SIZE  16
#define EAPOL_MIC_SIZE      16
#define EAPOL_ENCR_KEY_SIZE 16
#define MAC_ADDR_SIZE       6
#define TK_SIZE             16
#define HDR_8021x_LEN       4
#define KEYMGMTTIMEOUTVAL   10

typedef PACK_START struct
{
    UINT8 protocol_ver;
    UINT8 pckt_type;
    UINT16 pckt_body_len;
}
PACK_END Hdr_8021x_t;

typedef PACK_START struct
{ /*don't change this order */
UINT16 desc_ver :
    3;
UINT16 key_type :
    1;
UINT16 key_index :
    2;
UINT16 install :
    1;
UINT16 key_ack :
    1;
UINT16 key_MIC :
    1;
UINT16 secure :
    1;
UINT16 error :
    1;
UINT16 request :
    1;
UINT16 rsvd :
    4;

}
PACK_END key_info_t;

typedef PACK_START struct
{
    ether_hdr_t Ether_Hdr;
    Hdr_8021x_t hdr_8021x;
    UINT8 desc_type;
    PACK_START union
    {
        key_info_t key_info;
        UINT16 key_info16; /*key_info as UINT16 */
    }PACK_END k;
    UINT16 key_length;
    UINT32 replay_cnt[2];
    UINT8 key_nonce[NONCE_SIZE]; /*32 bytes */
    UINT8 EAPOL_key_IV[16];
    UINT8 key_RSC[8];
    UINT8 key_ID[8];
    UINT8 key_MIC[EAPOL_MIC_KEY_SIZE];
    UINT16 key_material_len;
    UINT8 key_data[1];
}
PACK_END EAPOL_KeyMsg_t;

#endif
