#ifndef _KEY_MGMT_STA_H_
#define _KEY_MGMT_STA_H_

#include "bufmgt.h"

typedef struct{
  Hsm super;
  State sta_hsk_start;
  State recvd_pwk_msg_1;
  State recvd_pwk_msg_3;
  State recvd_grp_msg_1;
  State sta_hsk_end;
//  Timer timer;
//  UINT8 timeout_ctr;
//  void *pData;
 }keyMgmtStahsk_hsm_t;

typedef struct
{
    UINT8 PairwiseTempKey[TK_SIZE];
    UINT32 RSNPwkTxMICKey[2];
    UINT32 RSNPwkRxMICKey[2];
    UINT32 RSNDataTrafficEnabled;
    UINT32 TxIV32;
    UINT32 RxIV32;
    UINT16 TxIV16;
}KeyData_t;

typedef struct
{
    UINT8 ANonce[NONCE_SIZE];
    UINT8 SNonce[NONCE_SIZE];
    UINT8 EAPOL_MIC_Key[EAPOL_MIC_KEY_SIZE];
    UINT8 EAPOL_Encr_Key[EAPOL_ENCR_KEY_SIZE];
    UINT8 PairwiseTempKey_tmp[TK_SIZE];
    UINT32 RSNPwkTxMICKey_tmp[2];
    UINT32 RSNPwkRxMICKey_tmp[2];
    UINT32 counter; /*store only the lower counter */
    /*actually we should store both the lower and the upper counter. But */
    /*  in our implementation we only increment the lower counter */
    UINT8 RsnIEBuf[MAX_SIZE_RSN_IE_BUF];
    UINT8 TimeoutCtr;
    UINT16 Phase1KeyTx[5];
    UINT16 Phase1KeyRx[5];
    keyMgmtStahsk_hsm_t keyMgmtStaHskHsm;
    KeyData_t *pKeyData;
}keyMgmtInfoSta_t;

#if !defined(PORTABLE_ARCH)
inline USR_BUF_DESC *(*ProcessWPAPcktStaFp)(USR_BUF_DESC *, WLAN_RX_FRAME **);
inline USR_BUF_DESC *ProcessTKIPPcktSta(USR_BUF_DESC *, WLAN_RX_FRAME **);
inline USR_BUF_DESC *ProcessCCMPPcktSta(USR_BUF_DESC *, WLAN_RX_FRAME **);
inline UINT32 (*DoWPAAndSchedFrameStaFp)(WLAN_TX_FRAME *Frame_p, UINT16);
inline UINT32 DoTKIPAndSchedFrameSta(WLAN_TX_FRAME *Frame_p, UINT16);
inline UINT32 DoCCMPAndSchedFrameSta(WLAN_TX_FRAME *Frame_p, UINT16);
#ifdef WPA2
inline USR_BUF_DESC *(*ProcessWPAPcktStaUnicastFp)(USR_BUF_DESC *, WLAN_RX_FRAME **);
inline USR_BUF_DESC *(*ProcessWPAPcktStaBcastFp)(USR_BUF_DESC *, WLAN_RX_FRAME **);
#endif
#else
extern USR_BUF_DESC *(*ProcessWPAPcktStaFp)(USR_BUF_DESC *, WLAN_RX_FRAME **);
INLINE USR_BUF_DESC *ProcessTKIPPcktSta(USR_BUF_DESC *, WLAN_RX_FRAME **);
INLINE USR_BUF_DESC *ProcessCCMPPcktSta(USR_BUF_DESC *, WLAN_RX_FRAME **);
extern UINT32 (*DoWPAAndSchedFrameStaFp)(WLAN_TX_FRAME *Frame_p, UINT16);
INLINE UINT32 DoTKIPAndSchedFrameSta(WLAN_TX_FRAME *Frame_p, UINT16);
INLINE UINT32 DoCCMPAndSchedFrameSta(WLAN_TX_FRAME *Frame_p, UINT16);
#ifdef WPA2
INLINE USR_BUF_DESC *(*ProcessWPAPcktStaUnicastFp)(USR_BUF_DESC *, WLAN_RX_FRAME **);
INLINE USR_BUF_DESC *(*ProcessWPAPcktStaBcastFp)(USR_BUF_DESC *, WLAN_RX_FRAME **);
#endif
#endif

#endif
