/*
*                Copyright 2003, Marvell International Ltd.
* This code contains confidential information of Marvell Semiconductor, Inc.
* No rights are granted herein under any patent, mask work right or copyright
* of Marvell or any third party.
* Marvell reserves the right at its sole discretion to request that this code
* be immediately returned to Marvell. This code is provided "as is".
* Marvell makes no warranties, express, implied or otherwise, regarding its
* accuracy, completeness or performance.
*/

/*!
 * \file    pool.h
 * \brief   The implementation of the fixed-size memory pool.
 *
*/

#ifndef POOL_H
#define POOL_H

#ifdef VXWORKS_BUFFER_OPT
#include "netBufLib.h"

typedef NET_POOL    POOL;
#else
typedef
struct _POOL {                  /* Fixed-block-size Buffer Pool */
   void *free__;                /* linked list of free blocks */
   unsigned short bufSz__;      /* maximum buffer size (in bytes) */
   unsigned short nTot__;       /* total number of buffers */
   unsigned short nFree__;      /* number of free blocks remaining */
   unsigned short nMin__;       /* minimum number of free blocks */
   void *start__;               /* 1st buffer in the pool */
   void *end__;                 /* last buffer in the pool */
   void *freeTail__;
}POOL;
#endif

typedef char BUF;

POOL *poolCreate(POOL *p, BUF *pool, unsigned nBuf, unsigned bufSz);
BUF *poolGet(POOL *p, int sz);
int poolPut(POOL *p, BUF *buf);

#endif                          /* POOL_H */
