#if !defined(_DEFAULTS_H_)
#define _DEFAULTS_H_ 
/*
 *                Copyright 2003, Marvell Semiconductor, Inc.
 * This code contains confidential information of Marvell Semiconductor, Inc.
 * No rights are granted herein under any patent, mask work right or copyright
 * of Marvell or any third party.
 * Marvell reserves the right at its sole discretion to request that this code
 * be immediately returned to Marvell. This code is provided "as is".
 * Marvell makes no warranties, express, implied or otherwise, regarding its
 * accuracy, completeness or performance.
 */

/*!
 * \file    defaults.h
 * \brief   System default values
 */

#define DEFAULT_RF_CHANNEL 11
#define DEFAULT_TX_QID TC0_QID

#define DEFAULT_RETRY_COUNT 3
#define DEFAULT_TX_DATARATE_ID 2 /* 0:1Mbit, 1:2Mbit, 2:5.5Mbit, 4:11Mbit */
#define DEFAULT_TX_PARAM       0x0100 /* Value for TxParam in txInfo_t */
#define DEFAULT_ACK_TMO_A      0x00000150 /* Value for "ACK timeout register A" */
#define DEFAULT_ACK_TMO_B      0x00000150 /* Value for "ACK timeout register B" */
#define DEFAULT_ACK_TMO_G      0x00000150 /* Value for "ACK timeout register G" */

#define DEFAULT_EDCF_TXOP_VAL  0x50

#define DEFAULT_CWMAX_VAL 0x100
#endif /*_DEFAULTS_H_ */

